#include <stdio.h>
#include <stdlib.h>

unsigned char ms_pal_header[] = {
   0x52, 0x49, 0x46, 0x46, 0x14, 0x04, 0x00, 0x00,
   0x50, 0x41, 0x4C, 0x20, 0x64, 0x61, 0x74, 0x61,
   0x08, 0x04, 0x00, 0x00, 0x00, 0x03, 0x00, 0x01
};
char strtmp[512];

int main (int argc, char ** argv)
{
   FILE * in, * out;
   int  i, r, g, b;


   if (argc != 2)
   {
      printf("syntaxe : psppal2mspal <file>.pal\n");
      exit(1);
   }

   in = fopen(argv[1], "rt");
   if (in == NULL)
   {
      printf("can't open \"%s\"\n", argv[1]);
      exit(1);
   }

   sprintf(strtmp, "%s.ms", argv[1]);
   out = fopen(strtmp, "wb");
   if (out == NULL)
   {
      fclose(in);
      printf("can't write \"%s\"\n", strtmp);
      exit(1);
   }

   fscanf(in, "%s", strtmp);
   fscanf(in, "%s", strtmp);
   fscanf(in, "%s", strtmp);

   for (i=0; i < 24; i++)
      fputc(ms_pal_header[i], out);

   for (i=0; i < 256; i++)
   {
      fscanf(in, "%i %i %i", &r, &g, &b);
      fputc(r, out);
      fputc(g, out);
      fputc(b, out);
      fputc(0x00, out);
   }
   fputc(0x00, out);
   fputc(0x00, out);
   fputc(0x00, out);
   fputc(0x00, out);

   // end
   fclose(in);
   fclose(out);
   return 0;
}
